/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================
*/

#include "../include/common.h"
#include "../include/workspace.h"

struct _OzGtkXML *OzGtkXML_ParseFile(gchar *);

#warning "ExtractElements - UNFINISHED"
void ExtractElements(struct _OzGtkXML *XML,guint level) {
    struct _OzGtkXML *XMLTemp;
    guint i;
    level++;
    for(i=0;i<g_list_length(XML->Elements);i++) {
	XMLTemp = g_list_nth_data(XML->Elements,i);
#ifdef DEBUG
	g_print("[%d] %d - %s(%s)\n",level,i,XMLTemp->name,XMLTemp->value);
#endif
	switch(level) {
	    case 1: /* Livello UNO - Object */
		    break;
	    case 2: /* Livello DUE - Proprieta' dell'oggetto e Bookmarks */
		    if(g_ascii_strcasecmp(XMLTemp->name,"FileName")==0) {
		        OzEDIT_CreateNewObject((gchar *)XMLTemp->value);
		    }
		    break;
	    case 3: /* Livello TRE - Proprieta' dei Bookmarks */
		    break;
	    default:
		    break;
	}	
        if(XMLTemp->Elements != NULL) ExtractElements(XMLTemp,level);	
    }

}

/* === Open Workspace ================================== */
#warning "OpneWorkspsce - UNFINISHED"
void OzEDIT_OpenWorkspace(gchar *wsfilename) {
    struct _OzGtkXML *XMLRoot;
    XMLRoot = OzGtkXML_ParseFile(wsfilename);
    if(XMLRoot == NULL) {
	OzEDIT_ErrorDialog("Cannot read file %s !",wsfilename);
	return;
    }
    ExtractElements(XMLRoot,0);
}

/* === Save Workspace ================================== */
void OzEDIT_SaveWorkspace(gchar *wsfilename) {
    struct _OzEDIT_Object *object;
    struct _OzEDIT_Bookmark *bookmark;
    GtkTextIter iter;
    FILE *f;
    guint i,ii;
    if(!g_str_has_suffix(wsfilename,".ows")) { /* l'estenzione OWS non e' stata messa, aggiungila */
	g_strlcat(wsfilename,".ows",255); /* SEGFAULT ? */
    }
    f = fopen(wsfilename,"w");
    if(f == NULL) {
	OzEDIT_ErrorDialog("Cannot create/write file %s !",wsfilename);
	return;
    }
    /* Ora procedi a salvare il WorkSpace in pseudo-XML */
    fprintf(f,"! OzEDITor WorkSpace http://ozeditor.zerozone.it \n");
    fprintf(f,"! v%02d.%02d.%02d \n",OZEDIT_VERSION,OZEDIT_SUBVERSION,OZEDIT_PATCH);
    /* Oggetti */
    fprintf(f,"! Objects Section \n");    
    for(i=0;i<g_list_length(topclass.objects);i++) {
	object = g_list_nth_data(topclass.objects,i);
	fprintf(f,"<Object>\n");
	fprintf(f,"  <Name \"%s\">\n",object->name);
	fprintf(f,"  <FileName \"%s\">\n",object->filename);	
        for(ii=0;ii<g_list_length(object->bookmarks);ii++) {
	    bookmark = g_list_nth_data(object->bookmarks,ii);
	    gtk_text_buffer_get_iter_at_mark(object->text_buffer,&iter,gtk_text_buffer_get_mark(object->text_buffer,bookmark->name));
    	    fprintf(f,"  <Bookmark>\n");
	    fprintf(f,"     <Name \"%s\">\n",bookmark->name);	
	    fprintf(f,"     <BKName \"%s\">\n",bookmark->bk_name);
	    fprintf(f,"     <Line \"%d\">\n",gtk_text_iter_get_line(&iter));
	    fprintf(f,"     <LineOff \"%d\">\n",gtk_text_iter_get_line_offset(&iter));
    	    fprintf(f,"  </Bookmark>\n");		    
	}
	fprintf(f,"</Object>\n");
    }
    fprintf(f,"! End \n");    
    fclose(f);
}

/* === Close Workspace ================================== */
void OzEDIT_CloseWorkspace(gchar *wsfilename) {

}

